<script lang="ts">
  import SuitIcon from "./icons/SuitIcon.svelte";
  import { getRank, getSuit } from "../serverUtils";
  import { send, receive } from "./cardCrossfade";

  export let card: Card;

  $: suit = suitHint ? getSuit(card) : null;
  $: rank = rankHint ? getRank(card) : null;

  export let suitHint: boolean = false;
  export let rankHint: boolean = false;
  export let showHint: boolean = false;

  function getRankClass(suit: Suit | null): string {
    switch (suit) {
      case "W":
        return "white-suit";
      case "Y":
        return "yellow-suit";
      case "G":
        return "green-suit";
      case "B":
        return "blue-suit";
      case "R":
        return "red-suit";
      case null:
        return "unknown-suit";
    }
  }
</script>

<div in:receive={{ key: card }} out:send={{ key: card }}>
  <div class="wrapper shadow">
    <div class="inner">
      <div class="corner">
        <div class={`rank ${getRankClass(suit)}`}>
          {#if showHint && rank !== null}{rank}{:else}&nbsp;{/if}
        </div>
        {#if showHint && suit !== null}
          <div class="suit">
            <SuitIcon {suit} />
          </div>
        {/if}
      </div>
    </div>
  </div>
</div>

<style>
  .wrapper {
    background-color: linen;
    position: relative;
    width: 10em;
    height: 14em;
    border-radius: 7% / 5%;
    border: 0.05em solid lightgray;
  }

  .inner {
    background: repeating-linear-gradient(
        45deg,
        #00000010,
        #00000010 5%,
        #00000020 5%,
        #00000020 10%
      ),
      repeating-linear-gradient(
        -45deg,
        #00000010,
        #00000010 5%,
        #00000020 5%,
        #00000020 10%
      ),
      radial-gradient(#616370, #444652);

    border-radius: inherit;
    position: absolute;
    top: 5%;
    bottom: 5%;
    left: 7%;
    right: 7%;
  }

  .corner {
    margin-top: 0.25em;
    margin-left: 0.5em;
    width: 2em;
    text-align: center;
  }
  .rank {
    font-size: 2em;
    font-weight: 900;
  }
  .suit {
    width: 2em;
  }
  .white-suit {
    color: #ebebeb;
  }
  .yellow-suit {
    color: #fdd835;
  }
  .green-suit {
    color: #9ccd65;
  }
  .blue-suit {
    color: #6bd1ff;
  }
  .red-suit {
    color: #f0413d;
  }
  .unknown-suit {
    color: #444652;
    text-shadow: 0 0 0.12em #fff, 0 0 0.12em #fff, 0 0 0.12em #fff,
      0 0 0.12em #fff, 0 0 0.12em #fff, 0 0 0.12em #fff, 0 0 0.12em #fff,
      0 0 0.12em #fff, 0 0 0.12em #fff, 0 0 0.12em #fff;
  }
</style>
